Index: asp3_wo_tecs/trunk/MANIFEST
===================================================================
--- asp3_wo_tecs/trunk/MANIFEST	(revision 305)
+++ asp3_wo_tecs/trunk/MANIFEST	(revision 306)
@@ -2,5 +2,5 @@
 VERSION 3.0.0
 
-configure
+configure.rb
 MANIFEST
 README.txt
@@ -10,4 +10,5 @@
 doc/design.txt
 doc/extension.txt
+doc/migration.txt
 doc/porting.txt
 doc/user.txt
@@ -26,49 +27,49 @@
 kernel/alarm.c
 kernel/alarm.h
-kernel/alarm.tf
+kernel/alarm.trb
 kernel/allfunc.h
 kernel/check.h
 kernel/cyclic.c
 kernel/cyclic.h
-kernel/cyclic.tf
+kernel/cyclic.trb
 kernel/dataqueue.c
 kernel/dataqueue.h
-kernel/dataqueue.tf
+kernel/dataqueue.trb
 kernel/eventflag.c
 kernel/eventflag.h
-kernel/eventflag.tf
+kernel/eventflag.trb
 kernel/exception.c
 kernel/exception.h
-kernel/exception.tf
-kernel/genoffset.tf
+kernel/exception.trb
+kernel/genoffset.trb
 kernel/interrupt.c
 kernel/interrupt.h
-kernel/interrupt.tf
-kernel/kernel.tf
-kernel/kernel_api.csv
-kernel/kernel_check.tf
-kernel/kernel_def.csv
+kernel/interrupt.trb
+kernel/kernel.trb
+kernel/kernel_api.def
+kernel/kernel_check.trb
 kernel/kernel_impl.h
 kernel/kernel_int.h
 kernel/kernel_rename.def
 kernel/kernel_rename.h
+kernel/kernel_sym.def
 kernel/kernel_unrename.h
 kernel/mempfix.c
 kernel/mempfix.h
-kernel/mempfix.tf
+kernel/mempfix.trb
 kernel/mutex.c
 kernel/mutex.h
-kernel/mutex.tf
+kernel/mutex.trb
 kernel/pridataq.c
 kernel/pridataq.h
-kernel/pridataq.tf
+kernel/pridataq.trb
 kernel/semaphore.c
 kernel/semaphore.h
-kernel/semaphore.tf
+kernel/semaphore.trb
 kernel/startup.c
 kernel/sys_manage.c
 kernel/task.c
 kernel/task.h
-kernel/task.tf
+kernel/task.trb
 kernel/task_manage.c
 kernel/task_refer.c
@@ -83,19 +84,50 @@
 kernel/wait.h
 
-syssvc/banner.c
-syssvc/banner.cfg
-syssvc/banner.h
-syssvc/histogram.c
+tecs_kernel/init_tecs.c
+tecs_kernel/kernel.cdl
+tecs_kernel/tAlarmNotifier.c
+tecs_kernel/tAlarmNotifier_inline.h
+tecs_kernel/tCpuExceptionHandler.c
+tecs_kernel/tCyclicNotifier.c
+tecs_kernel/tCyclicNotifier_inline.h
+tecs_kernel/tDataqueue_inline.h
+tecs_kernel/tEventflag_inline.h
+tecs_kernel/tFixedSizeMemoryPool_inline.h
+tecs_kernel/tISR.c
+tecs_kernel/tInitializeRoutine.c
+tecs_kernel/tInterruptHandler.c
+tecs_kernel/tInterruptRequest_inline.h
+tecs_kernel/tKernel_inline.h
+tecs_kernel/tMutex_inline.h
+tecs_kernel/tPriorityDataqueue_inline.h
+tecs_kernel/tSemaphore_inline.h
+tecs_kernel/tTask.c
+tecs_kernel/tTask_inline.h
+tecs_kernel/tTerminateRoutine.c
+tecs_kernel/tTimeEventHandler.c
+tecs_kernel/tecs_kernel.h
+
 syssvc/histogram.h
-syssvc/logtask.c
-syssvc/logtask.cfg
-syssvc/logtask.h
-syssvc/serial.c
-syssvc/serial.cfg
 syssvc/serial.h
-syssvc/syslog.c
-syssvc/syslog.cfg
 syssvc/syslog.h
-syssvc/test_svc.c
+syssvc/tHistogram.c
+syssvc/tHistogram.cdl
+syssvc/tHistogram.h
+syssvc/tHistogramAdapter.c
+syssvc/tHistogramAdapter.cdl
+syssvc/tBanner.cdl
+syssvc/tBannerMain.c
+syssvc/tLogTask.cdl
+syssvc/tLogTaskMain.c
+syssvc/tSerialAdapter.c
+syssvc/tSerialAdapter.cdl
+syssvc/tSerialPort.cdl
+syssvc/tSerialPortMain.c
+syssvc/tSysLog.c
+syssvc/tSysLog.cdl
+syssvc/tSysLogAdapter.c
+syssvc/tSysLogAdapter.cdl
+syssvc/tTestService.c
+syssvc/tTestService.cdl
 syssvc/test_svc.h
 
@@ -107,20 +139,24 @@
 arch/gcc/tool_stddef.h
 
-arch/logtrace/trace_config.h
-arch/logtrace/trace_config.c
-arch/logtrace/trace_config.cfg
-arch/logtrace/trace_dump.c
+arch/tracelog/trace_log.h
+arch/tracelog/tTraceLog.c
+arch/tracelog/tTraceLog.cdl
 
-utils/applyrename
-utils/genrename
-utils/gentest
-utils/makerelease
-utils/move-if-change
+utils/applyrename.rb
+utils/genrename.rb
+utils/gentest.rb
+utils/makerelease.rb
 
 sample/Makefile
 sample/sample1.c
+sample/sample1.cdl
 sample/sample1.cfg
 sample/sample1.h
+sample/tSample2.c
+sample/tSample2.cdl
+sample/tSample2.cfg
+sample/tSample2.h
 
+INCLUDE cfg/MANIFEST
 INCLUDE test/MANIFEST
 INCLUDE extension/MANIFEST
Index: asp3_wo_tecs/trunk/arch/arm_gcc/MANIFEST
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/MANIFEST	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/MANIFEST	(revision 306)
@@ -1,8 +1,9 @@
 PACKAGE asp3_arch_arm_gcc
-VERSION 3.0.0
+VERSION 3.1.0
 
 MANIFEST
 
 doc/arm_design.txt
+doc/arm_user.txt
 doc/gic_design.txt
 
@@ -11,13 +12,12 @@
 common/arm.h
 common/arm_insn.h
-common/core.tf
 common/core_asm.inc
 common/core_cfg1_out.h
-common/core_check.tf
-common/core_def.csv
+common/core_check.trb
 common/core_kernel.h
+common/core_kernel.trb
 common/core_kernel_impl.c
 common/core_kernel_impl.h
-common/core_offset.tf
+common/core_offset.trb
 common/core_rename.def
 common/core_rename.h
@@ -25,4 +25,6 @@
 common/core_stddef.h
 common/core_support.S
+common/core_sym.def
+common/core_syssvc.h
 common/core_test.h
 common/core_unrename.h
@@ -30,9 +32,15 @@
 common/gic_kernel_impl.h
 common/gic_support.S
+common/pl310.c
+common/pl310.h
 common/sp804.h
 common/start.S
-common/uart_pl011.c
+common/tUartPL011.c
+common/tUartPL011.cdl
 common/uart_pl011.h
 
 INCLUDE mpcore/MANIFEST
+INCLUDE rza1/MANIFEST
+
 INCLUDE ../../target/ct11mpcore_gcc/MANIFEST
+INCLUDE ../../target/gr_peach_gcc/MANIFEST
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/Makefile.core
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/Makefile.core	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/Makefile.core	(revision 306)
@@ -2,5 +2,5 @@
 #		Makefileã®ã³ã¢ä¾å­é¨ï¼ARMç¨ï¼
 #
-#  $Id: Makefile.core 484 2016-01-03 15:13:38Z ertl-hiro $
+#  $Id: Makefile.core 572 2016-02-01 14:40:09Z ertl-hiro $
 #
 
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/arm.h
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/arm.h	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/arm.h	(revision 306)
@@ -52,5 +52,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: arm.h 523 2016-01-14 11:01:04Z ertl-hiro $
+ *  $Id: arm.h 694 2016-03-23 13:17:48Z ertl-hiro $
  */
 
@@ -127,4 +127,5 @@
 #define CP15_SCTLR_VECTOR		UINT_C(0x00002000)
 #define CP15_SCTLR_ICACHE		UINT_C(0x00001000)
+#define CP15_SCTLR_BP			UINT_C(0x00000800)
 #define CP15_SCTLR_DCACHE		UINT_C(0x00000004)
 #define CP15_SCTLR_MMU			UINT_C(0x00000001)
@@ -308,4 +309,30 @@
 
 /*
+ *  åå²äºæ¸¬ãã¤ãã¼ãã«
+ */
+Inline void
+arm_enable_bp(void)
+{
+	uint32_t	reg;
+
+	CP15_READ_SCTLR(reg);
+	reg |= CP15_SCTLR_BP;
+	CP15_WRITE_SCTLR(reg);
+}
+
+/*
+ *  åå²äºæ¸¬ããã£ã¹ã¨ã¼ãã«
+ */
+Inline void
+arm_disable_bp(void)
+{
+	uint32_t	reg;
+
+	CP15_READ_SCTLR(reg);
+	reg &= ~CP15_SCTLR_BP;
+	CP15_WRITE_SCTLR(reg);
+}
+
+/*
  *  ãã­ã»ããµçªå·ã®åå¾
  *
@@ -413,4 +440,15 @@
 
 /*
+ *  åå²äºæ¸¬ã®ç¡å¹å
+ */
+Inline void
+arm_invalidate_bp(void)
+{
+	CP15_INVALIDATE_BP();
+	data_sync_barrier();
+	inst_sync_barrier();
+}
+
+/*
  *  TLBã®ç¡å¹å
  */
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/arm_insn.h
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/arm_insn.h	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/arm_insn.h	(revision 306)
@@ -52,5 +52,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: arm_insn.h 547 2016-01-16 06:26:08Z ertl-hiro $
+ *  $Id: arm_insn.h 694 2016-03-23 13:17:48Z ertl-hiro $
  */
 
@@ -245,4 +245,8 @@
 #define CP15_INVALIDATE_ICACHE() \
 								Asm("mcr p15, 0, %0, c7, c5, 0"::"r"(0))
+
+/* åå²äºæ¸¬å
+¨ä½ã®ç¡å¹å */
+#define CP15_INVALIDATE_BP()	Asm("mcr p15, 0, %0, c7, c5, 6"::"r"(0))
 
 /* ãã¼ã¿ã­ã£ãã·ã¥å
@@ -435,3 +439,13 @@
 }
 
+/*
+ *  CP15ã®ã»ã­ã¥ãªãã£æ¡å¼µã¬ã¸ã¹ã¿æä½ãã¯ã­ï¼ARMv7ã®ã¿ï¼
+ */
+#if __TARGET_ARCH_ARM == 7
+
+/* ãã¯ã¿ãã¼ã¹ã¢ãã¬ã¹ã¬ã¸ã¹ã¿ */
+#define CP15_READ_VBAR(reg)		Asm("mrc p15, 0, %0, c12, c0, 0":"=r"(reg))
+#define CP15_WRITE_VBAR(reg)	Asm("mcr p15, 0, %0, c12, c0, 0"::"r"(reg))
+
+#endif /* __TARGET_ARCH_ARM == 7 */
 #endif /* TOPPERS_ARM_INSN_H */
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/core_asm.inc
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/core_asm.inc	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/core_asm.inc	(revision 306)
@@ -3,5 +3,5 @@
  *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
- *  Copyright (C) 2011-2014 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2011-2016 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -50,5 +50,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: core_asm.inc 349 2015-07-25 05:25:27Z ertl-hiro $
+ *  $Id: core_asm.inc 714 2016-03-31 05:52:19Z ertl-hiro $
  */
 
@@ -82,3 +82,45 @@
 #define BSS_END			__end_bss
 
+/*
+ *  ãã¼ã¿ã¡ã¢ãªããªã¢
+ */
+	.macro	asm_data_memory_barrier reg1
+#ifdef ASM_DATA_MEMORY_BARRIER
+	ASM_DATA_MEMORY_BARRIER(reg1)
+#elif __TARGET_ARCH_ARM <= 6
+	mov		\reg1, #0
+	mcr		p15, 0, \reg1, c7, c10, 5
+#else /* __TARGET_ARCH_ARM <= 6 */
+	dmb
+#endif
+	.endm
+
+/*
+ *  ãã¼ã¿åæããªã¢
+ */
+	.macro	asm_data_sync_barrier reg1
+#ifdef ASM_DATA_SYNC_BARRIER
+	ASM_DATA_SYNC_BARRIER(reg1)
+#elif __TARGET_ARCH_ARM <= 6
+	mov		\reg1, #0
+	mcr		p15, 0, \reg1, c7, c10, 4
+#else /* __TARGET_ARCH_ARM <= 6 */
+	dsb
+#endif
+	.endm
+
+/*
+ *  å½ä»¤åæããªã¢
+ */
+	.macro	asm_inst_sync_barrier reg1
+#ifdef ASM_INST_SYNC_BARRIER
+	ASM_INST_SYNC_BARRIER(reg1)
+#elif __TARGET_ARCH_ARM <= 6
+	mov		\reg1, #0
+	mcr		p15, 0, \reg1, c7, c5, 4
+#else /* __TARGET_ARCH_ARM <= 6 */
+	isb
+#endif
+	.endm
+
 #endif /* TOPPERS_CORE_ASM_INC */
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/core_check.trb
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/core_check.trb	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/core_check.trb	(revision 306)
@@ -3,10 +3,10 @@
 #		ãã¹3ã®çæã¹ã¯ãªããã®ã³ã¢ä¾å­é¨ï¼ARMç¨ï¼
 # 
-#  $Id: core_check.trb 588 2016-02-05 12:54:58Z ertl-hiro $
+#  $Id: core_check.trb 730 2016-04-03 02:04:52Z ertl-hiro $
 #
 
-# 
+#
 #  ã¿ã¼ã²ããéä¾å­é¨ã®ã¤ã³ã¯ã«ã¼ã
-# 
+#
 IncludeTrb("kernel/kernel_check.trb")
 
@@ -27,5 +27,5 @@
     error_wrong_id("E_PAR", params, :inthdr, :inhno, "not aligned")
   end
-  if $CHECK_FUNC_NONNULL == 1 && inthdr == 0
+  if $CHECK_FUNC_NONNULL && inthdr == 0
     error_wrong_id("E_PAR", params, :inthdr, :inhno, "null")
   end
@@ -47,5 +47,5 @@
     error_wrong_id("E_PAR", params, :exchdr, :excno, "not aligned")
   end
-  if $CHECK_FUNC_NONNULL == 1 && exchdr == 0
+  if $CHECK_FUNC_NONNULL && exchdr == 0
     error_wrong_id("E_PAR", params, :exchdr, :excno, "null")
   end
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/core_kernel.h
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/core_kernel.h	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/core_kernel.h	(revision 306)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2016 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -53,5 +53,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: core_kernel.h 454 2015-08-16 03:18:46Z ertl-hiro $
+ *  $Id: core_kernel.h 718 2016-04-01 15:05:01Z ertl-hiro $
  */
 
@@ -109,4 +109,5 @@
 	uint32_t	r3;
 	uint32_t	r4;
+	uint32_t	r5;
 	uint32_t	r12;
 	uint32_t	lr;
@@ -125,4 +126,5 @@
 	uint32_t	r3;
 	uint32_t	r4;
+	uint32_t	r5;
 	uint32_t	r12;
 	uint32_t	lr;
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/core_kernel.trb
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/core_kernel.trb	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/core_kernel.trb	(revision 306)
@@ -53,5 +53,5 @@
 #   ã®è²¬ä»»ãè² ããªãï¼
 # 
-#   $Id: core_kernel.trb 572 2016-02-01 14:40:09Z ertl-hiro $
+#   $Id: core_kernel.trb 662 2016-02-27 02:33:51Z ertl-hiro $
 # 
 
@@ -96,5 +96,5 @@
 #  å²è¾¼ã¿è¦æ±ã©ã¤ã³è¨­å®ãã¼ãã«
 #
-if $USE_INTCFG_TABLE == 1
+if $USE_INTCFG_TABLE
   $kernelCfgC.comment_header("Interrupt Configuration Table")
 
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/core_kernel_impl.h
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/core_kernel_impl.h	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/core_kernel_impl.h	(revision 306)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2006-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -53,5 +53,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: core_kernel_impl.h 546 2016-01-16 06:00:09Z ertl-hiro $
+ *  $Id: core_kernel_impl.h 664 2016-02-29 16:32:29Z ertl-hiro $
  */
 
@@ -79,5 +79,5 @@
 #endif /* __thumb__ */
 #define CHECK_FUNC_NONNULL			/* é¢æ°ã®éNULLãã§ãã¯ */
-#define CHECK_STACK_ALIGN	4		/* ã¹ã¿ãã¯é åã®ã¢ã©ã¤ã³åä½ */
+#define CHECK_STACK_ALIGN	8		/* ã¹ã¿ãã¯é åã®ã¢ã©ã¤ã³åä½ */
 #define CHECK_STACK_NONNULL			/* ã¹ã¿ãã¯é åã®éNULLãã§ãã¯ */
 #define CHECK_MPF_ALIGN		4		/* åºå®é·ã¡ã¢ãªãã¼ã«é åã®ã¢ã©ã¤ã³åä½ */
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/core_rename.def
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/core_rename.def	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/core_rename.def	(revision 306)
@@ -42,4 +42,10 @@
 irc_end_exc
 
+# pl310.c
+pl310_initialize
+pl310_disable
+pl310_invalidate_all
+pl310_clean_and_invalidate_all
+
 # target_kernel_impl.c
 arm_tnum_memory_area
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/core_rename.h
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/core_rename.h	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/core_rename.h	(revision 306)
@@ -58,4 +58,12 @@
 
 /*
+ *  pl310.c
+ */
+#define pl310_initialize			_kernel_pl310_initialize
+#define pl310_disable				_kernel_pl310_disable
+#define pl310_invalidate_all		_kernel_pl310_invalidate_all
+#define pl310_clean_and_invalidate_all	_kernel_pl310_clean_and_invalidate_all
+
+/*
  *  target_kernel_impl.c
  */
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/core_sil.h
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/core_sil.h	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/core_sil.h	(revision 306)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2014 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2016 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -52,5 +52,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: core_sil.h 352 2015-07-25 06:36:42Z ertl-hiro $
+ *  $Id: core_sil.h 714 2016-03-31 05:52:19Z ertl-hiro $
  */
 
@@ -155,15 +155,4 @@
 #define SIL_UNL_INT()	(TOPPERS_set_fiq_irq(TOPPERS_fiq_irq_mask))
 
-/*
- *  å¾®å°æéå¾
-ã¡
- */
-Inline void
-sil_dly_nse(ulong_t dlytim) throw()
-{
-	register uint32_t r0 asm("r0") = (uint32_t) dlytim;
-	Asm("bl _sil_dly_nse" : "=g"(r0) : "0"(r0) : "lr","cc");
-}
-
 #endif /* TOPPERS_MACRO_ONLY */
 #endif /* TOPPERS_CORE_SIL_H */
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/core_support.S
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/core_support.S	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/core_support.S	(revision 306)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2006-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -53,5 +53,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: core_support.S 459 2015-08-29 13:03:42Z ertl-hiro $
+ *  $Id: core_support.S 733 2016-04-03 09:10:54Z ertl-hiro $
  */
 
@@ -72,5 +72,6 @@
  *  ä¾å¤ãã¯ã¿
  */
-	ASECTION(vector)
+	ASECTION(.vector)
+	AALIGN(5)
 	AGLOBAL(vector_table)
 ALABEL(vector_table)
@@ -122,5 +123,5 @@
 ã§å¼ã³åºãããï¼
 	 */
-	push	{lr}					/* æ»ãçªå°ãä¿å­ */
+	push	{r12,lr}				/* æ»ãçªå°ãä¿å­ï¼r12ã¯ããã¼ */
 #ifdef TOPPERS_SUPPORT_OVRHDR
 	bl		ovrtimer_stop
@@ -139,5 +140,5 @@
 	bl		ovrtimer_start
 #endif /* TOPPERS_SUPPORT_OVRHDR */
-	pop		{lr}					/* æ»ãçªå°ãå¾©å¸° */
+	pop		{r12,lr}				/* æ»ãçªå°ãå¾©å¸° */
 	bx		lr
 
@@ -325,5 +326,5 @@
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_IRQ_BIT)
-	stmfd	sp!, {r0-r4,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
+	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
 
 	/*
@@ -339,5 +340,5 @@
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_IRQ_BIT)
-	str		r2, [sp,#0x1c]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
+	str		r2, [sp,#0x20]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
 	push	{r1}					/* spsrãã¹ã¿ãã¯ã«ä¿å­ */
 #else /* __TARGET_ARCH_ARM < 6 */
@@ -354,6 +355,13 @@
 	 */
 	cps		#CPSR_SVC_MODE
-	stmfd	sp!, {r0-r4,r12,lr}
+	stmfd	sp!, {r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
+
+	/*
+	 *  ã¹ã¿ãã¯ãã¤ã³ã¿ã®èª¿æ´
+	 */
+	and		r1, sp, #4
+	sub		sp, sp, r1
+	push	{r0,r1}					/* r0ã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
 
 	/*
@@ -378,9 +386,9 @@
 	 *  éã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ã®ã¹ã¿ãã¯ã«åãæããï¼
 	 */
-	mov		r1, sp					/* ãã®æç¹ã®ã¹ã¿ãã¯ãã¤ã³ã¿ãr1ã« */
+	mov		r3, sp					/* ãã®æç¹ã®ã¹ã¿ãã¯ãã¤ã³ã¿ãr3ã« */
 	ldr		r2, =istkpt				/* éã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ã®ã¹ã¿ãã¯ã« */
 	ldr		sp, [r2]
-	push	{r1}					/* åæãåã®ã¹ã¿ãã¯ãã¤ã³ã¿ãä¿å­ */
-
+	push	{r0,r3}					/* åæãåã®ã¹ã¿ãã¯ãã¤ã³ã¿ãä¿å­ */
+									/* r0ã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
 ALABEL(irq_handler_1)
 	/*
@@ -388,7 +396,12 @@
 	 */
 	bl		irc_begin_int
-	cmp		r4, #TNUM_INHNO			/* ã¹ããªã¢ã¹å²è¾¼ã¿ãªã */
-	bhs		irq_handler_2			/*  irq_handler_2ã«åå² */
-
+#if TNUM_INHNO <= 256 || __TARGET_ARCH_ARM <= 6
+	cmp		r4, #TNUM_INHNO			/* TNUM_INHNOã®å¤ã«ãã£ã¦ã¯ã¨ã©ã¼ã«ãªã */
+#else /* TNUM_INHNO <= 256 || __TARGET_ARCH_ARM <= 6 */
+	movw	r3, #TNUM_INHNO
+	cmp		r4, r3			
+#endif /* TNUM_INHNO <= 256 || __TARGET_ARCH_ARM <= 6 */
+	bhs		irq_handler_2			/* ã¹ããªã¢ã¹å²è¾¼ã¿ãªã */
+									/*  irq_handler_2ã«åå² */
 	/*
 	 *  CPUã­ãã¯è§£é¤ç¶æ
@@ -447,5 +460,4 @@
 ALABEL(irq_handler_2)
 	bl		irc_end_int
-#endif /* OMIT_IRQ_HANDLER */
 
 	/*
@@ -462,6 +474,6 @@
 	 *  ã¿ã¹ã¯ç¨ã®ã¹ã¿ãã¯ã«æ»ãï¼
 	 */
-	pop		{r1}
-	mov   	sp, r1
+	pop		{r0,r3}
+	mov   	sp, r3
 
 	/*
@@ -469,5 +481,4 @@
 è¦ãå¤å®ããï¼
 	 */
-ALABEL(ret_int_1)
 	ldr		r0, =p_runtsk			/* p_runtsk â r0 */
 	ldr		r0, [r0]
@@ -482,5 +493,5 @@
 	tst		r0, r0					/* p_runtskãNULLãªãdispatcher_0ã¸ */
 	beq		dispatcher_0
-	stmfd	sp!, {r5-r11}			/* éã¹ã¯ã©ããã¬ã¸ã¹ã¿ã®ä¿å­ */
+	stmfd	sp!, {r6-r11}			/* éã¹ã¯ã©ããã¬ã¸ã¹ã¿ã®ä¿å­ */
 	str		sp, [r0,#TCB_sp]		/* ã¹ã¿ãã¯ãã¤ã³ã¿ãä¿å­ */
 	adr		r1, ret_int_r			/* å®è¡åéçªå°ãä¿å­ */
@@ -492,5 +503,5 @@
 	 *  ã³ã³ãã­ã¹ããå¾©å¸°ããï¼
 	 */
-	ldmfd	sp!, {r5-r11}			/* éã¹ã¯ã©ããã¬ã¸ã¹ã¿ã®å¾©å¸° */
+	ldmfd	sp!, {r6-r11}			/* éã¹ã¯ã©ããã¬ã¸ã¹ã¿ã®å¾©å¸° */
 
 #ifdef TOPPERS_SUPPORT_OVRHDR
@@ -516,12 +527,14 @@
 #endif /* TOPPERS_SUPPORT_OVRHDR */
 ALABEL(irq_handler_3)
+	pop		{r0,r1}					/* ã¹ã¿ãã¯ãã¤ã³ã¿ã®èª¿æ´ */
+	add		sp, sp, r1
 #if __TARGET_ARCH_ARM < 6
 	ldmfd	sp!, {r0}				/* æ»ãå
 ã®cpsrãspsrã«è¨­å® */
 	msr		spsr_cxsf, r0
-	ldmfd	sp!, {r0-r4,r12,lr,pc}^	/* ã³ã³ãã­ã¹ãã®å¾©å¸° */
+	ldmfd	sp!, {r0-r5,r12,lr,pc}^	/* ã³ã³ãã­ã¹ãã®å¾©å¸° */
 									/* ^ä»ããªã®ã§ï¼spsr â cpsr */
 #else /* __TARGET_ARCH_ARM < 6 */
-	ldmfd	sp!, {r0-r4,r12,lr}
+	ldmfd	sp!, {r0-r5,r12,lr}
 	rfefd	sp!
 #endif /* __TARGET_ARCH_ARM < 6 */
@@ -536,4 +549,5 @@
 	b		irq_handler_3
 #endif /* TOPPERS_SUPPORT_OVRHDR */
+#endif /* OMIT_IRQ_HANDLER */
 
 /*
@@ -560,5 +574,5 @@
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	stmfd	sp!, {r0-r4,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
+	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
 
 	/*
@@ -573,5 +587,5 @@
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	str		r2, [sp,#0x1c]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
+	str		r2, [sp,#0x20]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
 	push	{r1}					/* spsrãã¹ã¿ãã¯ã«ä¿å­ */
 #else /* __TARGET_ARCH_ARM < 6 */
@@ -587,5 +601,5 @@
 	 */
 	cps		#CPSR_SVC_MODE
-	stmfd	sp!, {r0-r4,r12,lr}
+	stmfd	sp!, {r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
 	mov		r4, #EXCNO_UNDEF
@@ -609,5 +623,5 @@
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	stmfd	sp!, {r0-r4,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
+	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
 
 	/*
@@ -620,5 +634,5 @@
 	 *  æ»ãçªå°ã¨spsrãä¿å­ããï¼
 	 */
-	str		r2, [sp,#0x1c]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
+	str		r2, [sp,#0x20]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
 	push	{r1}					/* spsrãã¹ã¿ãã¯ã«ä¿å­ */
 #else /* __TARGET_ARCH_ARM < 6 */
@@ -634,5 +648,5 @@
 	 */
 	cps		#CPSR_SVC_MODE			/* ä¸è¦ã¨æããã */
-	stmfd	sp!, {r0-r4,r12,lr}
+	stmfd	sp!, {r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
 	mov		r4, #EXCNO_SVC
@@ -657,5 +671,5 @@
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	stmfd	sp!, {r0-r4,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
+	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
 
 	/*
@@ -670,5 +684,5 @@
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	str		r2, [sp,#0x1c]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
+	str		r2, [sp,#0x20]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
 	push	{r1}					/* spsrãã¹ã¿ãã¯ã«ä¿å­ */
 #else /* __TARGET_ARCH_ARM < 6 */
@@ -684,5 +698,5 @@
 	 */
 	cps		#CPSR_SVC_MODE
-	stmfd	sp!, {r0-r4,r12,lr}
+	stmfd	sp!, {r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
 	mov		r4, #EXCNO_PABORT
@@ -720,5 +734,5 @@
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	stmfd	sp!, {r0-r4,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
+	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
 
 	/*
@@ -733,5 +747,5 @@
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	str		r2, [sp,#0x1c]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
+	str		r2, [sp,#0x20]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
 	push	{r1}					/* spsrãã¹ã¿ãã¯ã«ä¿å­ */
 #else /* __TARGET_ARCH_ARM < 6 */
@@ -747,5 +761,5 @@
 	 */
 	cps		#CPSR_SVC_MODE
-	stmfd	sp!, {r0-r4,r12,lr}
+	stmfd	sp!, {r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
 	mov		r4, #EXCNO_DABORT
@@ -766,5 +780,5 @@
 	ldr		sp, =istkpt
 	ldr		sp, [sp]
-	stmfd	sp!, {r0-r4,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
+	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
 
 	/*
@@ -779,5 +793,5 @@
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	str		r2, [sp,#0x1c]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
+	str		r2, [sp,#0x20]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
 	push	{r1}					/* spsrãã¹ã¿ãã¯ã«ä¿å­ */
 #else /* __TARGET_ARCH_ARM < 6 */
@@ -786,5 +800,5 @@
 	 *  ã¯ãã¤ã³ã¿ãåæåããï¼
 	 */
-	cpsid	if,#CPSR_SVC_MODE
+	cpsid	if, #CPSR_SVC_MODE
 	ldr		sp, =istkpt
 	ldr		sp, [sp]
@@ -802,5 +816,5 @@
 	 */
 	cps		#CPSR_SVC_MODE
-	stmfd	sp!, {r0-r4,r12,lr}
+	stmfd	sp!, {r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
 
@@ -833,5 +847,5 @@
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	stmfd	sp!, {r0-r4,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
+	stmfd	sp!, {r0-r5,r12,lr,pc}		/* pcã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
 
 	/*
@@ -846,5 +860,5 @@
 	 */
 	msr		cpsr_c, #(CPSR_SVC_MODE AOR CPSR_FIQ_IRQ_BIT)
-	str		r2, [sp,#0x1c]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
+	str		r2, [sp,#0x20]			/* æ»ãçªå°ãã¹ã¿ãã¯ã«ä¿å­ */
 	push	{r1}					/* spsrãã¹ã¿ãã¯ã«ä¿å­ */
 #else /* __TARGET_ARCH_ARM < 6 */
@@ -860,5 +874,5 @@
 	 */
 	cps		#CPSR_SVC_MODE
-	stmfd	sp!, {r0-r4,r12,lr}
+	stmfd	sp!, {r0-r5,r12,lr}
 #endif /* __TARGET_ARCH_ARM < 6 */
 	mov		r4, #EXCNO_FIQ
@@ -875,5 +889,5 @@
  * ããã®æç¹ã®ã¬ã¸ã¹ã¿ç¶æ
 ã
- *  r0ï¼CPUä¾å¤ãã³ãã©çªå·
+ *  r4ï¼CPUä¾å¤ãã³ãã©çªå·
  */
 ALABEL(exc_handler_1)
@@ -889,8 +903,15 @@
 	ldr		r3, [r2]
 	push	{r3}					/* ä¾å¤ãã¹ãã«ã¦ã³ããä¿å­ */
-	mov		r12, sp					/* CPUä¾å¤ã®æ
+	mov		r5, sp					/* CPUä¾å¤ã®æ
 å ±ãè¨æ¶ãã¦ããé åã® */
-									/*				å
-é ­çªå°ãr12ã«ä¿å­ */
+									/*				  å
+é ­çªå°ãr5ã«ä¿å­ */
+	/*
+	 *  ã¹ã¿ãã¯ãã¤ã³ã¿ã®èª¿æ´
+	 */
+	and		r1, sp, #4
+	sub		sp, sp, r1
+	push	{r0,r1}					/* r0ã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
+
 	/*
 	 *  ã«ã¼ãã«ç®¡çå¤ã®CPUä¾å¤ãå¤å®ãã
@@ -905,5 +926,5 @@
 	 *  ã®ãããããã»ããããã¦ãããªãï¼ããè©²å½ããï¼
 	 */
-	ldr		r1, [r12,#T_EXCINF_cpsr]	/* ä¾å¤ãã¬ã¼ã ããcpsrãåå¾ */
+	ldr		r1, [r5,#T_EXCINF_cpsr]		/* ä¾å¤ãã¬ã¼ã ããcpsrãåå¾ */
 	ands	r1, r1, #CPSR_FIQ_IRQ_BIT
 	bne		nk_exc_handler_1		/* ã«ã¼ãã«ç®¡çå¤ã®CPUä¾å¤ã®å¦çã¸ */
@@ -915,5 +936,5 @@
 	 *  r3ï¼excpt_nest_countã®å¤
 	 *  r4ï¼CPUä¾å¤ãã³ãã©çªå·
-	 *  r12ï¼CPUä¾å¤ã®æ
+	 *  r5ï¼CPUä¾å¤ã®æ
 å ±ãè¨æ¶ãã¦ããé åã®å
 é ­çªå°
@@ -932,7 +953,5 @@
 	 *  ãªã¼ãã©ã³ã¿ã¤ããåæ­¢ããï¼
 	 */
-	push	{r12}
 	bl		ovrtimer_stop
-	pop		{r12}
 #endif /* TOPPERS_SUPPORT_OVRHDR */
 
@@ -943,6 +962,6 @@
 	ldr		r2, =istkpt				/* éã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ã®ã¹ã¿ãã¯ã« */
 	ldr		sp, [r2]
-	push	{r3}					/* åæãåã®ã¹ã¿ãã¯ãã¤ã³ã¿ãä¿å­ */
-
+	push	{r0,r3}					/* åæãåã®ã¹ã¿ãã¯ãã¤ã³ã¿ãä¿å­ */
+									/* r0ã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
 ALABEL(exc_handler_2)
 	/*
@@ -950,5 +969,5 @@
 ã
 	 *  r4ï¼CPUä¾å¤ãã³ãã©çªå·
-	 *  r12ï¼CPUä¾å¤ã®æ
+	 *  r5ï¼CPUä¾å¤ã®æ
 å ±ãè¨æ¶ãã¦ããé åã®å
 é ­çªå°
@@ -982,8 +1001,6 @@
 	 */
 #ifdef LOG_EXC_ENTER
-	push	{r12}
 	mov		r0, r4					/* CPUä¾å¤çªå·ããã©ã¡ã¼ã¿ã«æ¸¡ã */
 	bl		log_exc_enter
-	pop		{r12}
 #endif /* LOG_EXC_ENTER */
 
@@ -993,5 +1010,5 @@
 	ldr		r2, =exc_table			/* CPUä¾å¤ãã³ãã©ãã¼ãã«ã®èª­è¾¼ã¿ */
 	ldr		r3, [r2,r4,lsl #2]		/* CPUä¾å¤ãã³ãã©ã®çªå° â r3 */
-	mov		r0, r12					/* CPUä¾å¤ã®æ
+	mov		r0, r5					/* CPUä¾å¤ã®æ
 å ±ãè¨æ¶ãã¦ããé åã® */
 									/*		å
@@ -1035,30 +1052,88 @@
 	ldr		r3, [r2]
 	subs	r3, r3, #1
-	str		r3, [r2]
+	str		r3, [r2]				/* æ»ãå
+ãéã¿ã¹ã¯ã³ã³ãã­ã¹ããªã */
+	bne		exc_handler_3			/*				exc_handler_3ã«åå² */
 
 	/*
 	 *  ã¿ã¹ã¯ç¨ã®ã¹ã¿ãã¯ã«æ»ãï¼
 	 */
-	popeq	{r1}					/* æ»ãå
-ãã¿ã¹ã¯ã³ã³ãã­ã¹ããªã */
-	moveq	sp, r1					/*		 ã¿ã¹ã¯ç¨ã®ã¹ã¿ãã¯ã«æ»ã */
+	pop		{r0,r3}
+	mov		sp, r3
+
+	/*
+	 *  ãã£ã¹ããããå¿
+è¦ãå¤å®ããï¼
+	 */
+	ldr		r0, =p_runtsk			/* p_runtsk â r0 */
+	ldr		r0, [r0]
+	ldr		r1, =p_schedtsk			/* p_schedtsk â r1 */
+	ldr		r1, [r1]
+	teq		r0, r1					/* p_runtskã¨p_schedtskãåããªã */
+	beq		exc_handler_4			/*				  exc_handler_4ã¸ */
+
+	/*
+	 *  ã³ã³ãã­ã¹ããä¿å­ããï¼
+	 */
+	tst		r0, r0					/* p_runtskãNULLãªãdispatcher_0ã¸ */
+	beq		dispatcher_0
+	stmfd	sp!, {r6-r11}			/* éã¹ã¯ã©ããã¬ã¸ã¹ã¿ã®ä¿å­ */
+	str		sp, [r0,#TCB_sp]		/* ã¹ã¿ãã¯ãã¤ã³ã¿ãä¿å­ */
+	adr		r1, ret_exc_r			/* å®è¡åéçªå°ãä¿å­ */
+	str		r1, [r0,#TCB_pc]
+	b		dispatcher				/* r0ã«ã¯p_runtskãæ ¼ç´ããã¦ãã */
+
+ALABEL(ret_exc_r)
+	/*
+	 *  ã³ã³ãã­ã¹ããå¾©å¸°ããï¼
+	 */
+	ldmfd	sp!, {r6-r11}			/* éã¹ã¯ã©ããã¬ã¸ã¹ã¿ã®å¾©å¸° */
+
+#ifdef TOPPERS_SUPPORT_OVRHDR
+	/*
+	 *  ãªã¼ãã©ã³ã¿ã¤ããåä½éå§ããï¼
+	 */
+	bl		ovrtimer_start
+#endif /* TOPPERS_SUPPORT_OVRHDR */
+
+	/*
+	 *  CPUä¾å¤å¦çããã®ãªã¿ã¼ã³
+	 *
+	 *  CPUä¾å¤å¦çããã®ãªã¿ã¼ã³ã«ããï¼CPUã­ãã¯è§£é¤ç¶æ
+ã«é·ç§»ããã
+	 *  ãã«ããå¿
+è¦ããããï¼ARMã¯CPSRã®ãããã«ãã£ã¦CPUã­ãã¯ç¶æ
+ã
+	 *  è¡¨ãã¦ããããï¼CPSRãå
+ã«æ»ãã¦ãªã¿ã¼ã³ããã°ããï¼
+	 */
+#ifndef TOPPERS_SUPPORT_OVRHDR
+ALABEL(exc_handler_4)
+#endif /* TOPPERS_SUPPORT_OVRHDR */
+ALABEL(exc_handler_3)
+	pop		{r0,r1}					/* ã¹ã¿ãã¯ãã¤ã³ã¿ã®èª¿æ´ */
+	add		sp, sp, r1
 	add		sp, sp, #8				/* ã¹ã¿ãã¯ä¸ã®æ
 å ±ãæ¨ã¦ã */
-	beq		ret_int_1				/* ret_int_1ã«åå² */
-
-	/*
-	 *  CPUä¾å¤å¦çããã®ãªã¿ã¼ã³ï¼irq_handler_3ã¨åãå¦çå
-å®¹ï¼
-	 */
 #if __TARGET_ARCH_ARM < 6
 	ldmfd	sp!, {r0}				/* æ»ãå
 ã®cpsrãspsrã«è¨­å® */
 	msr		spsr_cxsf, r0
-	ldmfd	sp!, {r0-r4,r12,lr,pc}^	/* ã³ã³ãã­ã¹ãã®å¾©å¸° */
+	ldmfd	sp!, {r0-r5,r12,lr,pc}^	/* ã³ã³ãã­ã¹ãã®å¾©å¸° */
 									/* ^ä»ããªã®ã§ï¼spsr â cpsr */
 #else /* __TARGET_ARCH_ARM < 6 */
-	ldmfd	sp!, {r0-r4,r12,lr}
+	ldmfd	sp!, {r0-r5,r12,lr}
 	rfefd	sp!
 #endif /* __TARGET_ARCH_ARM < 6 */
+
+#ifdef TOPPERS_SUPPORT_OVRHDR
+ALABEL(exc_handler_4)
+	/*
+	 *  ãªã¼ãã©ã³ã¿ã¤ããåä½éå§ããï¼
+	 */
+	tst		r0, r0					/* p_runtskãNULLã§ãªãå ´å */
+	blne	ovrtimer_start
+	b		exc_handler_3
+#endif /* TOPPERS_SUPPORT_OVRHDR */
 
 /*
@@ -1074,5 +1149,5 @@
 	 *  r3ï¼excpt_nest_countã®å¤
 	 *  r4ï¼CPUä¾å¤ãã³ãã©çªå·
-	 *  r12ï¼CPUä¾å¤ã®æ
+	 *  r5ï¼CPUä¾å¤ã®æ
 å ±ãè¨æ¶ãã¦ããé åã®å
 é ­çªå°
@@ -1093,6 +1168,6 @@
 	ldr		r2, =istkpt				/* éã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ã®ã¹ã¿ãã¯ã« */
 	ldr		sp, [r2]
-	push	{r3}					/* åæãåã®ã¹ã¿ãã¯ãã¤ã³ã¿ãä¿å­ */
-
+	push	{r0,r3}					/* åæãåã®ã¹ã¿ãã¯ãã¤ã³ã¿ãä¿å­ */
+									/* r0ã¯ã¹ãã¼ã¹ç¢ºä¿ã®ãã */
 ALABEL(nk_exc_handler_2)
 	/*
@@ -1109,5 +1184,5 @@
 	ldr		r2, =exc_table			/* CPUä¾å¤ãã³ãã©ãã¼ãã«ã®èª­è¾¼ã¿ */
 	ldr		r3, [r2,r4,lsl #2]		/* CPUä¾å¤ãã³ãã©ã®çªå° â r3 */
-	mov		r0, r12					/* CPUä¾å¤ã®æ
+	mov		r0, r5					/* CPUä¾å¤ã®æ
 å ±ãè¨æ¶ãã¦ããé åã® */
 									/*		å
@@ -1123,44 +1198,14 @@
 	ldr		r3, [r2]
 	subs	r3, r3, #1
-	str		r3, [r2]
+	str		r3, [r2]				/* æ»ãå
+ãéã¿ã¹ã¯ã³ã³ãã­ã¹ããªã */
+	bne		exc_handler_3			/*				exc_handler_3ã«åå² */
 
 	/*
 	 *  ã¿ã¹ã¯ç¨ã®ã¹ã¿ãã¯ã«æ»ãï¼
 	 */
-	popeq	{r1}					/* æ»ãå
-ãã¿ã¹ã¯ã³ã³ãã­ã¹ããªã */
-	moveq	sp, r1					/*		 ã¿ã¹ã¯ç¨ã®ã¹ã¿ãã¯ã«æ»ã */
-	add		sp, sp, #8				/* ã¹ã¿ãã¯ä¸ã®æ
-å ±ãæ¨ã¦ã */
-
-	/*
-	 *  CPUä¾å¤å¦çããã®ãªã¿ã¼ã³ï¼irq_handler_3ã¨åãå¦çå
-å®¹ï¼
-	 */
-#if __TARGET_ARCH_ARM < 6
-	ldmfd	sp!, {r0}				/* æ»ãå
-ã®cpsrãspsrã«è¨­å® */
-	msr		spsr_cxsf, r0
-	ldmfd	sp!, {r0-r4,r12,lr,pc}^	/* ã³ã³ãã­ã¹ãã®å¾©å¸° */
-									/* ^ä»ããªã®ã§ï¼spsr â cpsr */
-#else /* __TARGET_ARCH_ARM < 6 */
-	ldmfd	sp!, {r0-r4,r12,lr}
-	rfefd	sp!
-#endif /* __TARGET_ARCH_ARM < 6 */
-
-/*
- *  å¾®å°æéå¾
-ã¡
- */
-	ATEXT
-	AALIGN(2)
-	AGLOBAL(_sil_dly_nse)
-ALABEL(_sil_dly_nse)
-	subs	r0, r0, #SIL_DLY_TIM1
-	bxls	lr
-ALABEL(_sil_dly_nse1)
-	subs	r0, r0, #SIL_DLY_TIM2
-	bhi		_sil_dly_nse1
-	bx		lr
+	pop		{r0,r3}
+	mov		sp, r3
+	b		exc_handler_3
 
 /*
@@ -1186,2 +1231,27 @@
 
 #endif /* __thumb__ */
+
+/*
+ *  å¾®å°æéå¾
+ã¡
+ *
+ *  ã­ã£ãã·ã¥ã©ã¤ã³ã®ã©ã®å ´æã«ãããã®ãã£ã¦å®è¡æéãå¤ããããï¼å¤§
+ *  ããã®åä½ã§ã¢ã©ã¤ã³ãã¦ããï¼
+ */
+	ATEXT
+	AALIGN(8)
+	AGLOBAL(sil_dly_nse)
+ALABEL(sil_dly_nse)
+	mov		r1, #0
+	mcr		p15, 0, r1, c7, c5, 6		/* åå²äºæ¸¬å
+¨ä½ã®ç¡å¹å */
+	asm_inst_sync_barrier r3
+	subs	r0, r0, #SIL_DLY_TIM1
+	bxls	lr
+ALABEL(sil_dly_nse1)
+	mcr		p15, 0, r1, c7, c5, 6		/* åå²äºæ¸¬å
+¨ä½ã®ç¡å¹å */
+	asm_inst_sync_barrier r3
+	subs	r0, r0, #SIL_DLY_TIM2
+	bhi		sil_dly_nse1
+	bx		lr
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/core_sym.def
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/core_sym.def	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/core_sym.def	(revision 306)
@@ -1,4 +1,4 @@
 TARGET_ARCH_ARM,__TARGET_ARCH_ARM
-USE_INTCFG_TABLE,1,,defined(USE_INTCFG_TABLE)
+USE_INTCFG_TABLE,true,bool,defined(USE_INTCFG_TABLE)
 sizeof_TCB,sizeof(TCB)
 offsetof_TCB_p_tinib,"offsetof(TCB,p_tinib)"
Index: asp3_wo_tecs/trunk/arch/arm_gcc/common/core_unrename.h
===================================================================
--- asp3_wo_tecs/trunk/arch/arm_gcc/common/core_unrename.h	(revision 305)
+++ asp3_wo_tecs/trunk/arch/arm_gcc/common/core_unrename.h	(revision 306)
@@ -59,4 +59,12 @@
 
 /*
+ *  pl310.c
+ */
+#undef pl310_initialize
+#undef pl310_disable
+#undef pl310_invalidate_all
+#undef pl310_clean_and_invalidate_all
+
+/*
  *  target_kernel_impl.c
  */
